// WinampProxyDemo.cs
// Written by David J. Stein, Esq., 9/5/2008
// See "License.html" for terms and conditions of use.
//
// This is just a simple demo project for the WinampInterface and WinampProxy classes.

#region Using declarations

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;

#endregion

namespace WinampProxyNS {

  public class WinampProxyDemo : System.Windows.Forms.Form {

    #region Variables, initialization code, and Main

    private System.Windows.Forms.Button btnPlay;
    private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button btnEnqueueTrack;
    private System.Windows.Forms.Button button5;
		private System.Windows.Forms.Button button7;
    private System.Windows.Forms.Button button8;
    private Timer timerUpdate;
    private Label label3;
    private Label label2;
    private Label label5;
    private Label label7;
    private TextBox txtTrackTitle;
    private TextBox txtTrackDuration;
    private TextBox txtTrackPosition;
    private TextBox txtStatus;
    private TextBox txtShuffle;
    private Label label1;
    private Button btnStartWinamp;
    private Button btnShowWinamp;
    private Button btnHideWinamp;
    private Button btnToggleEqualizer;
    private TextBox txtWinampVersion;
    private Label label8;
    private TextBox txtRepeat;
    private Label label9;
    private TextBox txtEqualizer;
    private Label label6;
    private TextBox txtPlaylistDuration;
    private Label label4;
    private TextBox txtPlaylistRemaining;
    private Label label10;
    private GroupBox groupEvents;
    private ListBox lbEvents;
    private IContainer components;

    private WinampProxy wp = new WinampProxy();
    private Button btnClearPlaylist;
    private Label label11;
    private TrackBar tbVolume;
    private Button btnToggleShuffle;
    private Button btnToggleRepeat;
    private Button btnShowUserControl;
    private List<string> lstAddEvents = new List<string>();

    [STAThread]
    static void Main() {
      Application.Run(new WinampProxyDemo());
    }

    public WinampProxyDemo() {
			InitializeComponent();
		}

    private void FrmMain_Load(object sender, EventArgs e) {
      wp.eventWinampInstanceCreated += new WinampProxy.WinampProxyEventDelegate(AddEvent_WinampInstanceCreated);
      wp.eventWinampInstanceClosed += new WinampProxy.WinampProxyEventDelegate(AddEvent_WinampInstanceClosed);
      wp.eventPlayStarted += new WinampProxy.WinampProxyEventDelegate(AddEvent_PlayStarted);
      wp.eventPlayStopped += new WinampProxy.WinampProxyEventDelegate(AddEvent_PlayStopped);
      wp.eventTrackChanged += new WinampProxy.WinampProxyEventDelegate(AddEvent_TrackChanged);
      wp.eventEnqueuePrompt += new WinampProxy.WinampProxyEventDelegate(AddEvent_EnqueuePrompt);
    }

    protected override void Dispose(bool disposing) {
			if (disposing) {
				if (components != null) {
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.components = new System.ComponentModel.Container();
      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(WinampProxyDemo));
      this.btnPlay = new System.Windows.Forms.Button();
      this.button2 = new System.Windows.Forms.Button();
      this.btnEnqueueTrack = new System.Windows.Forms.Button();
      this.button5 = new System.Windows.Forms.Button();
      this.button7 = new System.Windows.Forms.Button();
      this.button8 = new System.Windows.Forms.Button();
      this.timerUpdate = new System.Windows.Forms.Timer(this.components);
      this.label3 = new System.Windows.Forms.Label();
      this.label2 = new System.Windows.Forms.Label();
      this.label5 = new System.Windows.Forms.Label();
      this.label7 = new System.Windows.Forms.Label();
      this.txtTrackTitle = new System.Windows.Forms.TextBox();
      this.txtTrackDuration = new System.Windows.Forms.TextBox();
      this.txtTrackPosition = new System.Windows.Forms.TextBox();
      this.txtStatus = new System.Windows.Forms.TextBox();
      this.txtShuffle = new System.Windows.Forms.TextBox();
      this.label1 = new System.Windows.Forms.Label();
      this.btnStartWinamp = new System.Windows.Forms.Button();
      this.btnShowWinamp = new System.Windows.Forms.Button();
      this.btnHideWinamp = new System.Windows.Forms.Button();
      this.btnToggleEqualizer = new System.Windows.Forms.Button();
      this.txtWinampVersion = new System.Windows.Forms.TextBox();
      this.label8 = new System.Windows.Forms.Label();
      this.txtRepeat = new System.Windows.Forms.TextBox();
      this.label9 = new System.Windows.Forms.Label();
      this.txtEqualizer = new System.Windows.Forms.TextBox();
      this.label6 = new System.Windows.Forms.Label();
      this.txtPlaylistDuration = new System.Windows.Forms.TextBox();
      this.label4 = new System.Windows.Forms.Label();
      this.txtPlaylistRemaining = new System.Windows.Forms.TextBox();
      this.label10 = new System.Windows.Forms.Label();
      this.groupEvents = new System.Windows.Forms.GroupBox();
      this.lbEvents = new System.Windows.Forms.ListBox();
      this.btnClearPlaylist = new System.Windows.Forms.Button();
      this.label11 = new System.Windows.Forms.Label();
      this.tbVolume = new System.Windows.Forms.TrackBar();
      this.btnToggleShuffle = new System.Windows.Forms.Button();
      this.btnToggleRepeat = new System.Windows.Forms.Button();
      this.btnShowUserControl = new System.Windows.Forms.Button();
      this.groupEvents.SuspendLayout();
      ((System.ComponentModel.ISupportInitialize) (this.tbVolume)).BeginInit();
      this.SuspendLayout();
      // 
      // btnPlay
      // 
      this.btnPlay.BackColor = System.Drawing.Color.Silver;
      this.btnPlay.Cursor = System.Windows.Forms.Cursors.Hand;
      this.btnPlay.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
      this.btnPlay.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte) (0)));
      this.btnPlay.ForeColor = System.Drawing.Color.White;
      this.btnPlay.Location = new System.Drawing.Point(119, 36);
      this.btnPlay.Name = "btnPlay";
      this.btnPlay.Size = new System.Drawing.Size(104, 23);
      this.btnPlay.TabIndex = 4;
      this.btnPlay.Text = "Play";
      this.btnPlay.UseVisualStyleBackColor = false;
      this.btnPlay.Click += new System.EventHandler(this.btnPlay_Click);
      // 
      // button2
      // 
      this.button2.BackColor = System.Drawing.Color.Silver;
      this.button2.Cursor = System.Windows.Forms.Cursors.Hand;
      this.button2.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
      this.button2.ForeColor = System.Drawing.Color.White;
      this.button2.Location = new System.Drawing.Point(119, 63);
      this.button2.Name = "button2";
      this.button2.Size = new System.Drawing.Size(48, 23);
      this.button2.TabIndex = 7;
      this.button2.Text = "Stop";
      this.button2.UseVisualStyleBackColor = false;
      this.button2.Click += new System.EventHandler(this.btnStop_Click);
      // 
      // btnEnqueueTrack
      // 
      this.btnEnqueueTrack.BackColor = System.Drawing.Color.Silver;
      this.btnEnqueueTrack.Cursor = System.Windows.Forms.Cursors.Hand;
      this.btnEnqueueTrack.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
      this.btnEnqueueTrack.ForeColor = System.Drawing.Color.White;
      this.btnEnqueueTrack.Location = new System.Drawing.Point(8, 36);
      this.btnEnqueueTrack.Name = "btnEnqueueTrack";
      this.btnEnqueueTrack.Size = new System.Drawing.Size(104, 23);
      this.btnEnqueueTrack.TabIndex = 3;
      this.btnEnqueueTrack.Text = "Enqueue Track";
      this.btnEnqueueTrack.UseVisualStyleBackColor = false;
      this.btnEnqueueTrack.Click += new System.EventHandler(this.btnEnqueueTrack_Click);
      // 
      // button5
      // 
      this.button5.BackColor = System.Drawing.Color.Silver;
      this.button5.Cursor = System.Windows.Forms.Cursors.Hand;
      this.button5.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
      this.button5.ForeColor = System.Drawing.Color.White;
      this.button5.Location = new System.Drawing.Point(175, 63);
      this.button5.Name = "button5";
      this.button5.Size = new System.Drawing.Size(48, 23);
      this.button5.TabIndex = 8;
      this.button5.Text = "Pause";
      this.button5.UseVisualStyleBackColor = false;
      this.button5.Click += new System.EventHandler(this.btnPause_Click);
      // 
      // button7
      // 
      this.button7.BackColor = System.Drawing.Color.Silver;
      this.button7.Cursor = System.Windows.Forms.Cursors.Hand;
      this.button7.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
      this.button7.ForeColor = System.Drawing.Color.White;
      this.button7.Location = new System.Drawing.Point(8, 63);
      this.button7.Name = "button7";
      this.button7.Size = new System.Drawing.Size(104, 23);
      this.button7.TabIndex = 6;
      this.button7.Text = "Previous Track";
      this.button7.UseVisualStyleBackColor = false;
      this.button7.Click += new System.EventHandler(this.btnPreviousTrack_Click);
      // 
      // button8
      // 
      this.button8.BackColor = System.Drawing.Color.Silver;
      this.button8.Cursor = System.Windows.Forms.Cursors.Hand;
      this.button8.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
      this.button8.ForeColor = System.Drawing.Color.White;
      this.button8.Location = new System.Drawing.Point(230, 63);
      this.button8.Name = "button8";
      this.button8.Size = new System.Drawing.Size(104, 23);
      this.button8.TabIndex = 9;
      this.button8.Text = "Next Track";
      this.button8.UseVisualStyleBackColor = false;
      this.button8.Click += new System.EventHandler(this.btnNextTrack_Click);
      // 
      // timerUpdate
      // 
      this.timerUpdate.Enabled = true;
      this.timerUpdate.Interval = 1000;
      this.timerUpdate.Tick += new System.EventHandler(this.timerUpdate_Tick);
      // 
      // label3
      // 
      this.label3.AutoSize = true;
      this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte) (0)));
      this.label3.Location = new System.Drawing.Point(7, 192);
      this.label3.Name = "label3";
      this.label3.Size = new System.Drawing.Size(61, 13);
      this.label3.TabIndex = 19;
      this.label3.Text = "Track Title:";
      // 
      // label2
      // 
      this.label2.AutoSize = true;
      this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte) (0)));
      this.label2.Location = new System.Drawing.Point(7, 216);
      this.label2.Name = "label2";
      this.label2.Size = new System.Drawing.Size(81, 13);
      this.label2.TabIndex = 21;
      this.label2.Text = "Track Duration:";
      // 
      // label5
      // 
      this.label5.AutoSize = true;
      this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte) (0)));
      this.label5.Location = new System.Drawing.Point(186, 215);
      this.label5.Name = "label5";
      this.label5.Size = new System.Drawing.Size(47, 13);
      this.label5.TabIndex = 23;
      this.label5.Text = "Position:";
      // 
      // label7
      // 
      this.label7.AutoSize = true;
      this.label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte) (0)));
      this.label7.Location = new System.Drawing.Point(187, 168);
      this.label7.Name = "label7";
      this.label7.Size = new System.Drawing.Size(40, 13);
      this.label7.TabIndex = 17;
      this.label7.Text = "Status:";
      // 
      // txtTrackTitle
      // 
      this.txtTrackTitle.Location = new System.Drawing.Point(76, 188);
      this.txtTrackTitle.Name = "txtTrackTitle";
      this.txtTrackTitle.ReadOnly = true;
      this.txtTrackTitle.Size = new System.Drawing.Size(260, 20);
      this.txtTrackTitle.TabIndex = 20;
      // 
      // txtTrackDuration
      // 
      this.txtTrackDuration.Location = new System.Drawing.Point(100, 211);
      this.txtTrackDuration.Name = "txtTrackDuration";
      this.txtTrackDuration.ReadOnly = true;
      this.txtTrackDuration.Size = new System.Drawing.Size(81, 20);
      this.txtTrackDuration.TabIndex = 22;
      // 
      // txtTrackPosition
      // 
      this.txtTrackPosition.Location = new System.Drawing.Point(254, 211);
      this.txtTrackPosition.Name = "txtTrackPosition";
      this.txtTrackPosition.ReadOnly = true;
      this.txtTrackPosition.Size = new System.Drawing.Size(81, 20);
      this.txtTrackPosition.TabIndex = 24;
      // 
      // txtStatus
      // 
      this.txtStatus.Location = new System.Drawing.Point(255, 165);
      this.txtStatus.Name = "txtStatus";
      this.txtStatus.ReadOnly = true;
      this.txtStatus.Size = new System.Drawing.Size(81, 20);
      this.txtStatus.TabIndex = 18;
      // 
      // txtShuffle
      // 
      this.txtShuffle.Location = new System.Drawing.Point(100, 257);
      this.txtShuffle.Name = "txtShuffle";
      this.txtShuffle.ReadOnly = true;
      this.txtShuffle.Size = new System.Drawing.Size(81, 20);
      this.txtShuffle.TabIndex = 30;
      // 
      // label1
      // 
      this.label1.AutoSize = true;
      this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte) (0)));
      this.label1.Location = new System.Drawing.Point(7, 261);
      this.label1.Name = "label1";
      this.label1.Size = new System.Drawing.Size(43, 13);
      this.label1.TabIndex = 29;
      this.label1.Text = "Shuffle:";
      // 
      // btnStartWinamp
      // 
      this.btnStartWinamp.BackColor = System.Drawing.Color.Silver;
      this.btnStartWinamp.Cursor = System.Windows.Forms.Cursors.Hand;
      this.btnStartWinamp.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
      this.btnStartWinamp.ForeColor = System.Drawing.Color.White;
      this.btnStartWinamp.Location = new System.Drawing.Point(8, 8);
      this.btnStartWinamp.Name = "btnStartWinamp";
      this.btnStartWinamp.Size = new System.Drawing.Size(104, 23);
      this.btnStartWinamp.TabIndex = 0;
      this.btnStartWinamp.Text = "Start Winamp";
      this.btnStartWinamp.UseVisualStyleBackColor = false;
      this.btnStartWinamp.Click += new System.EventHandler(this.btnStartWinamp_Click);
      // 
      // btnShowWinamp
      // 
      this.btnShowWinamp.BackColor = System.Drawing.Color.Silver;
      this.btnShowWinamp.Cursor = System.Windows.Forms.Cursors.Hand;
      this.btnShowWinamp.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
      this.btnShowWinamp.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte) (0)));
      this.btnShowWinamp.ForeColor = System.Drawing.Color.White;
      this.btnShowWinamp.Location = new System.Drawing.Point(120, 8);
      this.btnShowWinamp.Name = "btnShowWinamp";
      this.btnShowWinamp.Size = new System.Drawing.Size(104, 23);
      this.btnShowWinamp.TabIndex = 1;
      this.btnShowWinamp.Text = "Show Winamp";
      this.btnShowWinamp.UseVisualStyleBackColor = false;
      this.btnShowWinamp.Click += new System.EventHandler(this.btnShowWinamp_Click);
      // 
      // btnHideWinamp
      // 
      this.btnHideWinamp.BackColor = System.Drawing.Color.Silver;
      this.btnHideWinamp.Cursor = System.Windows.Forms.Cursors.Hand;
      this.btnHideWinamp.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
      this.btnHideWinamp.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte) (0)));
      this.btnHideWinamp.ForeColor = System.Drawing.Color.White;
      this.btnHideWinamp.Location = new System.Drawing.Point(230, 8);
      this.btnHideWinamp.Name = "btnHideWinamp";
      this.btnHideWinamp.Size = new System.Drawing.Size(104, 23);
      this.btnHideWinamp.TabIndex = 2;
      this.btnHideWinamp.Text = "Hide Winamp";
      this.btnHideWinamp.UseVisualStyleBackColor = false;
      this.btnHideWinamp.Click += new System.EventHandler(this.btnHideWinamp_Click);
      // 
      // btnToggleEqualizer
      // 
      this.btnToggleEqualizer.BackColor = System.Drawing.Color.Silver;
      this.btnToggleEqualizer.Cursor = System.Windows.Forms.Cursors.Hand;
      this.btnToggleEqualizer.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
      this.btnToggleEqualizer.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte) (0)));
      this.btnToggleEqualizer.ForeColor = System.Drawing.Color.White;
      this.btnToggleEqualizer.Location = new System.Drawing.Point(230, 90);
      this.btnToggleEqualizer.Name = "btnToggleEqualizer";
      this.btnToggleEqualizer.Size = new System.Drawing.Size(104, 23);
      this.btnToggleEqualizer.TabIndex = 12;
      this.btnToggleEqualizer.Text = "Toggle Equalizer";
      this.btnToggleEqualizer.UseVisualStyleBackColor = false;
      this.btnToggleEqualizer.Click += new System.EventHandler(this.btnToggleEqualizer_Click);
      // 
      // txtWinampVersion
      // 
      this.txtWinampVersion.Location = new System.Drawing.Point(76, 164);
      this.txtWinampVersion.Name = "txtWinampVersion";
      this.txtWinampVersion.ReadOnly = true;
      this.txtWinampVersion.Size = new System.Drawing.Size(81, 20);
      this.txtWinampVersion.TabIndex = 16;
      // 
      // label8
      // 
      this.label8.AutoSize = true;
      this.label8.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte) (0)));
      this.label8.Location = new System.Drawing.Point(7, 167);
      this.label8.Name = "label8";
      this.label8.Size = new System.Drawing.Size(45, 13);
      this.label8.TabIndex = 15;
      this.label8.Text = "Version:";
      // 
      // txtRepeat
      // 
      this.txtRepeat.Location = new System.Drawing.Point(255, 257);
      this.txtRepeat.Name = "txtRepeat";
      this.txtRepeat.ReadOnly = true;
      this.txtRepeat.Size = new System.Drawing.Size(81, 20);
      this.txtRepeat.TabIndex = 32;
      // 
      // label9
      // 
      this.label9.AutoSize = true;
      this.label9.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte) (0)));
      this.label9.Location = new System.Drawing.Point(186, 260);
      this.label9.Name = "label9";
      this.label9.Size = new System.Drawing.Size(45, 13);
      this.label9.TabIndex = 31;
      this.label9.Text = "Repeat:";
      // 
      // txtEqualizer
      // 
      this.txtEqualizer.Location = new System.Drawing.Point(77, 280);
      this.txtEqualizer.Name = "txtEqualizer";
      this.txtEqualizer.ReadOnly = true;
      this.txtEqualizer.Size = new System.Drawing.Size(259, 20);
      this.txtEqualizer.TabIndex = 34;
      // 
      // label6
      // 
      this.label6.AutoSize = true;
      this.label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte) (0)));
      this.label6.Location = new System.Drawing.Point(7, 285);
      this.label6.Name = "label6";
      this.label6.Size = new System.Drawing.Size(53, 13);
      this.label6.TabIndex = 33;
      this.label6.Text = "Equalizer:";
      // 
      // txtPlaylistDuration
      // 
      this.txtPlaylistDuration.Location = new System.Drawing.Point(101, 234);
      this.txtPlaylistDuration.Name = "txtPlaylistDuration";
      this.txtPlaylistDuration.ReadOnly = true;
      this.txtPlaylistDuration.Size = new System.Drawing.Size(81, 20);
      this.txtPlaylistDuration.TabIndex = 26;
      // 
      // label4
      // 
      this.label4.AutoSize = true;
      this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte) (0)));
      this.label4.Location = new System.Drawing.Point(7, 237);
      this.label4.Name = "label4";
      this.label4.Size = new System.Drawing.Size(85, 13);
      this.label4.TabIndex = 25;
      this.label4.Text = "Playlist Duration:";
      // 
      // txtPlaylistRemaining
      // 
      this.txtPlaylistRemaining.Location = new System.Drawing.Point(254, 234);
      this.txtPlaylistRemaining.Name = "txtPlaylistRemaining";
      this.txtPlaylistRemaining.ReadOnly = true;
      this.txtPlaylistRemaining.Size = new System.Drawing.Size(81, 20);
      this.txtPlaylistRemaining.TabIndex = 28;
      // 
      // label10
      // 
      this.label10.AutoSize = true;
      this.label10.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte) (0)));
      this.label10.Location = new System.Drawing.Point(185, 238);
      this.label10.Name = "label10";
      this.label10.Size = new System.Drawing.Size(60, 13);
      this.label10.TabIndex = 27;
      this.label10.Text = "Remaining:";
      // 
      // groupEvents
      // 
      this.groupEvents.Controls.Add(this.lbEvents);
      this.groupEvents.Location = new System.Drawing.Point(9, 307);
      this.groupEvents.Name = "groupEvents";
      this.groupEvents.Size = new System.Drawing.Size(327, 111);
      this.groupEvents.TabIndex = 35;
      this.groupEvents.TabStop = false;
      this.groupEvents.Text = "Events";
      // 
      // lbEvents
      // 
      this.lbEvents.FormattingEnabled = true;
      this.lbEvents.Location = new System.Drawing.Point(6, 19);
      this.lbEvents.Name = "lbEvents";
      this.lbEvents.Size = new System.Drawing.Size(315, 82);
      this.lbEvents.TabIndex = 0;
      // 
      // btnClearPlaylist
      // 
      this.btnClearPlaylist.BackColor = System.Drawing.Color.Silver;
      this.btnClearPlaylist.Cursor = System.Windows.Forms.Cursors.Hand;
      this.btnClearPlaylist.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
      this.btnClearPlaylist.ForeColor = System.Drawing.Color.White;
      this.btnClearPlaylist.Location = new System.Drawing.Point(230, 36);
      this.btnClearPlaylist.Name = "btnClearPlaylist";
      this.btnClearPlaylist.Size = new System.Drawing.Size(104, 23);
      this.btnClearPlaylist.TabIndex = 5;
      this.btnClearPlaylist.Text = "Clear Playlist";
      this.btnClearPlaylist.UseVisualStyleBackColor = false;
      this.btnClearPlaylist.Click += new System.EventHandler(this.btnClearPlaylist_Click);
      // 
      // label11
      // 
      this.label11.AutoSize = true;
      this.label11.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte) (0)));
      this.label11.Location = new System.Drawing.Point(8, 129);
      this.label11.Name = "label11";
      this.label11.Size = new System.Drawing.Size(45, 13);
      this.label11.TabIndex = 13;
      this.label11.Text = "Volume:";
      // 
      // tbVolume
      // 
      this.tbVolume.Location = new System.Drawing.Point(68, 117);
      this.tbVolume.Maximum = 255;
      this.tbVolume.Name = "tbVolume";
      this.tbVolume.Size = new System.Drawing.Size(276, 45);
      this.tbVolume.TabIndex = 14;
      this.tbVolume.TickFrequency = 16;
      this.tbVolume.TickStyle = System.Windows.Forms.TickStyle.Both;
      this.tbVolume.Value = 128;
      this.tbVolume.Scroll += new System.EventHandler(this.tbVolume_Scroll);
      // 
      // btnToggleShuffle
      // 
      this.btnToggleShuffle.BackColor = System.Drawing.Color.Silver;
      this.btnToggleShuffle.Cursor = System.Windows.Forms.Cursors.Hand;
      this.btnToggleShuffle.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
      this.btnToggleShuffle.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte) (0)));
      this.btnToggleShuffle.ForeColor = System.Drawing.Color.White;
      this.btnToggleShuffle.Location = new System.Drawing.Point(8, 90);
      this.btnToggleShuffle.Name = "btnToggleShuffle";
      this.btnToggleShuffle.Size = new System.Drawing.Size(104, 23);
      this.btnToggleShuffle.TabIndex = 10;
      this.btnToggleShuffle.Text = "Toggle Shuffle";
      this.btnToggleShuffle.UseVisualStyleBackColor = false;
      this.btnToggleShuffle.Click += new System.EventHandler(this.btnToggleShuffle_Click);
      // 
      // btnToggleRepeat
      // 
      this.btnToggleRepeat.BackColor = System.Drawing.Color.Silver;
      this.btnToggleRepeat.Cursor = System.Windows.Forms.Cursors.Hand;
      this.btnToggleRepeat.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
      this.btnToggleRepeat.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte) (0)));
      this.btnToggleRepeat.ForeColor = System.Drawing.Color.White;
      this.btnToggleRepeat.Location = new System.Drawing.Point(119, 90);
      this.btnToggleRepeat.Name = "btnToggleRepeat";
      this.btnToggleRepeat.Size = new System.Drawing.Size(104, 23);
      this.btnToggleRepeat.TabIndex = 11;
      this.btnToggleRepeat.Text = "Toggle Repeat";
      this.btnToggleRepeat.UseVisualStyleBackColor = false;
      this.btnToggleRepeat.Click += new System.EventHandler(this.btnToggleRepeat_Click);
      // 
      // btnShowUserControl
      // 
      this.btnShowUserControl.BackColor = System.Drawing.Color.Silver;
      this.btnShowUserControl.Cursor = System.Windows.Forms.Cursors.Hand;
      this.btnShowUserControl.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
      this.btnShowUserControl.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte) (0)));
      this.btnShowUserControl.ForeColor = System.Drawing.Color.White;
      this.btnShowUserControl.Location = new System.Drawing.Point(120, 424);
      this.btnShowUserControl.Name = "btnShowUserControl";
      this.btnShowUserControl.Size = new System.Drawing.Size(104, 23);
      this.btnShowUserControl.TabIndex = 36;
      this.btnShowUserControl.Text = "Show User Control";
      this.btnShowUserControl.UseVisualStyleBackColor = false;
      this.btnShowUserControl.Click += new System.EventHandler(this.btnShowUserControl_Click);
      // 
      // WinampProxyDemo
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(344, 450);
      this.Controls.Add(this.btnShowUserControl);
      this.Controls.Add(this.btnToggleRepeat);
      this.Controls.Add(this.btnToggleShuffle);
      this.Controls.Add(this.tbVolume);
      this.Controls.Add(this.label11);
      this.Controls.Add(this.btnClearPlaylist);
      this.Controls.Add(this.groupEvents);
      this.Controls.Add(this.txtPlaylistDuration);
      this.Controls.Add(this.label4);
      this.Controls.Add(this.txtPlaylistRemaining);
      this.Controls.Add(this.label10);
      this.Controls.Add(this.txtEqualizer);
      this.Controls.Add(this.label6);
      this.Controls.Add(this.txtRepeat);
      this.Controls.Add(this.label9);
      this.Controls.Add(this.txtWinampVersion);
      this.Controls.Add(this.label8);
      this.Controls.Add(this.btnToggleEqualizer);
      this.Controls.Add(this.btnHideWinamp);
      this.Controls.Add(this.btnShowWinamp);
      this.Controls.Add(this.btnStartWinamp);
      this.Controls.Add(this.txtShuffle);
      this.Controls.Add(this.label1);
      this.Controls.Add(this.txtStatus);
      this.Controls.Add(this.txtTrackPosition);
      this.Controls.Add(this.txtTrackDuration);
      this.Controls.Add(this.txtTrackTitle);
      this.Controls.Add(this.label7);
      this.Controls.Add(this.label5);
      this.Controls.Add(this.label2);
      this.Controls.Add(this.label3);
      this.Controls.Add(this.button8);
      this.Controls.Add(this.button7);
      this.Controls.Add(this.button5);
      this.Controls.Add(this.btnEnqueueTrack);
      this.Controls.Add(this.button2);
      this.Controls.Add(this.btnPlay);
      this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
      this.Icon = ((System.Drawing.Icon) (resources.GetObject("$this.Icon")));
      this.MaximizeBox = false;
      this.MinimizeBox = false;
      this.Name = "WinampProxyDemo";
      this.Text = "Winamp Proxy Demo";
      this.Load += new System.EventHandler(this.FrmMain_Load);
      this.groupEvents.ResumeLayout(false);
      ((System.ComponentModel.ISupportInitialize) (this.tbVolume)).EndInit();
      this.ResumeLayout(false);
      this.PerformLayout();

		}
		#endregion

    #endregion

    #region Button-click event handlers

    private void btnPlay_Click(object sender, System.EventArgs e) {
			wp.Play();
		}

		private void btnPause_Click(object sender, System.EventArgs e) {
			wp.Pause();
		}

		private void btnEnqueueTrack_Click(object sender, System.EventArgs e) {
      OpenFileDialog o = new OpenFileDialog();
      o.Multiselect = true;
      if (o.ShowDialog() == DialogResult.OK) {
        foreach (string strFilename in o.FileNames)
          wp.EnqueueTrack(strFilename);
      }
		}

		private void btnStop_Click(object sender, System.EventArgs e) {
      wp.Stop();
		}

		private void btnPreviousTrack_Click(object sender, System.EventArgs e) {
			wp.PrevTrack();
		}

		private void btnNextTrack_Click(object sender, System.EventArgs e) {
			wp.NextTrack();
		}

		private void btnVolumeUp_Click(object sender, System.EventArgs e) {
			wp.VolumeUp();
		}

		private void btnVolumeDown_Click(object sender, System.EventArgs e) {
			wp.VolumeDown();
		}

    private void btnStartWinamp_Click(object sender, EventArgs e) {
      wp.StartWinamp();
      wp.InitializeWinamp();
    }

    private void btnShowWinamp_Click(object sender, EventArgs e) {
      wp.ShowWinamp();
    }

    private void btnHideWinamp_Click(object sender, EventArgs e) {
      wp.HideWinamp();
    }

    private void btnToggleEqualizer_Click(object sender, EventArgs e) {
      wp.SetEqualizerActive(!wp.IsEqualizerActive());
    }

    private void btnDeactivateEqualizer_Click(object sender, EventArgs e) {
      wp.SetEqualizerActive(false);
    }

    private void btnToggleShuffle_Click(object sender, EventArgs e) {
      wp.SetShuffle(!wp.GetShuffle());
    }

    private void btnToggleRepeat_Click(object sender, EventArgs e) {
      wp.SetRepeat(!wp.GetRepeat());
    }

    private void tbVolume_Scroll(object sender, EventArgs e) {
      wp.SetVolume((int) tbVolume.Value);
    }

    private void btnClearPlaylist_Click(object sender, EventArgs e) {
      wp.ClearPlaylist();
    }

    private void btnShowUserControl_Click(object sender, EventArgs e) {
      new WinampUserControlDemo().ShowDialog();
    }

    #endregion

    #region Polling event handlers

    private void timerUpdate_Tick(object sender, EventArgs e) {
      txtTrackTitle.Text = wp.strCurrentTrackName;   // could also retrieve via wp.GetTrackTitle()
      txtTrackDuration.Text = wp.iCurrentTrackDuration.ToString();     // could also retrieve via wp.GetTrackLength()
      txtTrackPosition.Text = wp.iCurrentTrackPosition.ToString();   // could also retrieve via wp.GetTrackPosition()
      txtStatus.Text = wp.enumWinampStatus.ToString();  // could also retrieve via wp.GetWinampStatus()
      txtWinampVersion.Text = wp.GetWinampVersion().ToString();
      txtShuffle.Text = wp.GetShuffle().ToString();
      txtRepeat.Text = wp.GetRepeat().ToString();
      if (wp.IsEqualizerActive() == false)
        txtEqualizer.Text = "Off";
      else {
        string strEqualizer = "";
        for (int i = 0; i <= 11; i++)
          strEqualizer += (strEqualizer.Length > 0 ? " | " : "") + wp.GetEqualizerBand(i);
        txtEqualizer.Text = strEqualizer;
      }
      txtPlaylistDuration.Text = wp.CalculatePlaylistDuration(true).ToString();
      txtPlaylistRemaining.Text = wp.CalculatePlaylistRemainderDuration(true).ToString();
      if (lstAddEvents.Count > 0) {
        while (lstAddEvents.Count > 0) {
          lbEvents.Items.Add(lstAddEvents[0]);
          lstAddEvents.RemoveAt(0);
        }
        lbEvents.TopIndex = Math.Max(0, lbEvents.Items.Count - 6);
      }

    }

    private void AddEvent_WinampInstanceCreated() {
      lstAddEvents.Add("Winamp instance created.");
    }

    private void AddEvent_WinampInstanceClosed() {
      lstAddEvents.Add("Winamp instance closed.");
    }

    private void AddEvent_PlayStarted() {
      lstAddEvents.Add("Winamp is now playing.");
    }

    private void AddEvent_PlayStopped() {
      lstAddEvents.Add("Winamp has stopped playing.");
    }

    private void AddEvent_TrackChanged() {
      lstAddEvents.Add("Now playing track " + (wp.iPlaylistTrackNumber + 1) + ": " + wp.strCurrentTrackName);
    }

    private void AddEvent_EnqueuePrompt() {
      lstAddEvents.Add("Enqueue prompt: Queue has " + wp.iEnqueuePromptMilliseconds + " milliseconds left.");
    }

    #endregion

  }

}
